package FileFormatting;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.LinkedList;

public class ConvertClusters {

	/**
	 * @param args
	 */
	
	public static String Clusters2BeFormatted = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/CopiedFromExcel.txt";
	public static String ExportFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/Dataset/Clusters_version2.txt";
	
	public static LinkedList<String> Lines4Export = new LinkedList<String>();
	
	public static void main(String[] args) {
		ReadClusters();
		WriteClusters();
	}
	
	//read in clusters
	public static void ReadClusters(){
		try {
			BufferedReader br = new BufferedReader(new FileReader(Clusters2BeFormatted));
			String Line = null;
			while((Line = br.readLine()) != null){
				
				//split string, initialize output
				String[] L = Line.split("\\s+");
				String str = "";
				
				for (String s : L){
					
					//parse string
					if (s.startsWith("NC64A_")){
						s = s.substring(6);
					} else if (s.startsWith("SAG_")){
						s = s.substring(4);
					} else if (s.startsWith("Pbi_")){
						s = s.substring(4);
					}
					
					//replace appropraite underscore with vertical bar
					s = s.replace('_','|');
					if (s.contains("|Ref")){
						s = s.replace("|Ref","_Ref");
					}
					
					//add to line
					if (str.equals("")){
						str = s;
					} else {
						str = str + "\t" + s;
					}

				}

				//add new line, store for export
				str = str + "\n";
				Lines4Export.add(str);
			}
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	//export clusters
	public static void WriteClusters(){
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(ExportFile));
			for (String s : Lines4Export){
				bw.write(s);
				bw.flush();
			}
			bw.close();
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}

}
