package FileFormatting;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;

public class LoadData {

	/**
	 * (1) GFFs are imported directly into JCE from the DataDir folder.
	 * (2) This script generates re-formatted cluster files
	 */
	
	
	/*
	 * CURRENT
	 * 10-17-2013
	 */
	
	//retrieve data
	public static String DataDir = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/ChlorovirusesExtendedCoreOnly";
	
	//All 41
	//before 10-17-2013
	//public static String GFFListFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/Proximity_and_Unruliness/NewGFFs.txt";
	
	//UPDATE 10-17-2013
	//public static String GFFListFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/GFFList_Oct17.txt";
	
	//RERUN 07-28-2016
	public static String GFFListFile = "/Users/phillipseitzer/UCDavis/GeneGangs-2016-Revival/2016-07-28-gene-gangs-TEST/input/GFFList.txt";
	
	/*
	 * Original dataset file - for use with older versions (before Oct 17)
	 * Multiple member gene gangs
	 */
	
//	//Paths
//	public static String DataDir = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/Dataset";
//	
//	//All 41
//	public static String GFFListFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/Proximity_and_Unruliness/NewGFFs.txt";
	
	/*
	 * SUBSETS - for use with gene gang pairs analysis
	 */
	
	//Pbi + SAG
	//public static String GFFListFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/Proximity_and_Unruliness/SAG_Pbi.txt";
	
	//SAG + NC64A
	//public static String GFFListFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/Proximity_and_Unruliness/SAG_NC64A.txt";

	//Pbi + NC64A
	//public static String GFFListFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/Proximity_and_Unruliness/Pbi_NC64A.txt";
	
	//SAG
	//public static String GFFListFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/Proximity_and_Unruliness/SAG.txt";
	
	//Pbi
	//public static String GFFListFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/Proximity_and_Unruliness/Pbi.txt";
	
	//NC64A
	//public static String GFFListFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/Proximity_and_Unruliness/NC64A.txt";
	
	//One from each
	//public static String GFFListFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/Proximity_and_Unruliness/One_From_Each.txt";
	
	/*
	 * CLUSTERS
	 */
	
	//old
	//public static String ClusterFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/Dataset/Clusters.txt";
	
	//current from 9-11-2013 ==> 10-28-2013
	public static String ClusterFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/Dataset/Clusters_version2.txt";
	public static String ClusterMappingFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/ClusterAnnotationsFromExcelFile.txt";

	//Current as of 10-28-2013
	public static String CoreClustersFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/ChlorovirusCoreGenes.csv";
	public static String AllClustersFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/ChlorovirusAllClusters.csv";
	public static LinkedList<ClusterData> ClusterDirectory;
	public static LinkedHashMap<Integer, ClusterData> ClusterDirectoryHash;
	
	public static String GeneIDFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/GeneIDs.txt";
	public static String OutputFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/Clusters_JCE_Formatted.txt";
								//Shortened
	public static LinkedHashMap<String, LinkedList<GenomicFeature>> Chloroviruses;
								//Shortened, File
	public static LinkedHashMap<String, String> OrgNames;
	public static LinkedList<GenomicFeature> GFs4Export;
	
	//Cluster related
	public static LinkedHashMap<Integer, String> ClusterAnnotations = new LinkedHashMap<Integer, String>();
	public static int LargeClusterCutoff = 80; //9999; //old multiple member gene gang =80; // for pairs = 41;
	public static LinkedList<Integer> LargeClusters = new LinkedList<Integer>();
	public static int LargestCluster;
	
	//cluster counts			
	public static int CoreGeneCount = 0;
	public static int NonLargeCoreGeneCount = 0;
	public static int NonLargeNonCoreGeneCount = 0;
	
								// clusternum, counts
	public static LinkedHashMap<Integer,Integer> ClusterCounts;
	public static HashSet<GenomicFeature> ImportedNonLargeCoreGenes;
	
	public static String GFFExportDir = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/ChlorovirusesExtendedAll";
	public static String GFFNoMinorORFsExportDir = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/ChlorovirusesExtendedAllNoMinorORFs";
	
	// SEQUENCE RELATED
	
	//list of genome sequence files (nucleotide)
	public static String GenomeFile = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/GenomeSequencesFileList.txt"; 
	public static String TranslationFileList = "/Users/phillipseitzer/Dropbox/GeneGangsPaper/California/Phil/JCE_Files/TranslationFileList.txt";
	
	//data
	public static LinkedHashMap<String, String> TranslationFiles; //OrgName, File
	public static LinkedHashMap<String,String> GenomeFiles; //OrgName, File
	public static int FastaLineLength = 70;
	public static int BubbleRange = 30;
	
	// CLASSES
	 
	//Feature entry class
	public static class GenomicFeature {
		public String OrgName;
		public String Contig;
		public String Type;
		public String Strand;
		public int StartPos;
		public int StopPos;
		public int Size;
		public int CenterPos;
		public int ClusterNum;
		public String GeneID;
		public String Annotation;
		public String ProteinSequence;
	}
	
	//Cluster Data class
	public static class ClusterData {
		public String ClusterID;
		public int ClusterNum;
		public String Origin;
		public boolean isCore;
		public boolean isLargeCluster;
		public int Size;
		public String Annotation;
		public LinkedList<String> MemberGeneIDs;
	}
	
	// METHODS
	
	//Import list of organism names
	public static void ImportOrgNames(){
		try {
			BufferedReader br = new BufferedReader(new FileReader(GFFListFile));
			String Line = null;
			while ((Line = br.readLine()) != null){
				String[] Name = Line.trim().split(".gff");
				String[] NameOnly = Name[0].split("_");
				OrgNames.put(NameOnly[0], Name[0]);
			}
			br.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	//Import a single GFF file, and add data to list
	public static void ImportGFFFile(String filename, String orgname){
		LinkedList<GenomicFeature> Features = new LinkedList<GenomicFeature>();
		try {
			BufferedReader br = new BufferedReader(new FileReader(filename));
			String Line = null;
			while ((Line = br.readLine()) != null){
				if (!Line.startsWith("#") && !Line.isEmpty()){
					
					//split line
					String[] L = Line.split("\t");
					
					String PBCVID = "";
					//appropriate types
					if (L[2].equals("CDS") || L[2].equals("tRNA") || L[2].equals("rRNA")){
						
						//Read data from file -> GF object
						GenomicFeature GF = new GenomicFeature();
						GF.OrgName = orgname;
						GF.Contig = L[0];
						GF.Type = L[2];
						GF.StartPos = Integer.parseInt(L[3]);
						GF.StopPos = Integer.parseInt(L[4]);
						GF.Strand = L[6];
						
						//Determine center
						int Length = GF.StopPos - GF.StartPos;
						GF.CenterPos = (int) Math.round(0.5*(double)Length) + GF.StartPos;
						GF.Size = GF.StopPos - GF.StartPos + 1;
						//System.out.println("Start: " + GF.StartPos + " Center: " + GF.CenterPos + " Stop: " + GF.StopPos );
						 
						//determine gene ID
						String Annotation = L[8];
						String[] AnnSplit = Annotation.split(";");
						GF.Annotation = Annotation;
						
						//New set 10-17-2013
						if (L.length > 9){
							
							//retrieve cluster num
							int ClusterNum = Integer.parseInt(L[9]);
							
							//store counts
							if (ClusterNum != 0){
								if (ClusterCounts.get(ClusterNum) != null){
									int Count = ClusterCounts.get(ClusterNum);
									Count++;
									ClusterCounts.put(ClusterNum, Count);
								} else {
									ClusterCounts.put(ClusterNum,1);
								}
								
								//increment
								CoreGeneCount++;
							}
							
							
							
							//UPDATE 10-28-2013
							//no need to add this cluster - now relying on new cluster set
							//store clusternum in feature
							GF.ClusterNum = Integer.parseInt(L[9]);
							
							//retrieve ID
							if (L.length > 10){
								GF.GeneID = L[10];
							}
						}
						
						//for debugging
						if (GF.ClusterNum != 0){
							ImportedNonLargeCoreGenes.add(GF);
						}
						
						
//						//ORF_Final - formatted
//						
//						if (filename.contains("ORF_Final")){
//							if (GF.Type.equals("CDS")){
//								GF.GeneID = AnnSplit[0].substring(7);
//							} else if (GF.Type.equals("tRNA")){
//								GF.GeneID = AnnSplit[0].substring(3);
//							}
//						} else if (filename.contains("_Genes")){
//							if (GF.Type.equals("CDS")){
//								if (filename.contains("PBCV1")){
//									String[] AnnParts = Annotation.substring(7).split("\\.1");
//									GF.GeneID = "PBCV1_Ref|" + AnnParts[0];
//									//System.out.println(GF.GeneID);
//								} else {
//									GF.GeneID = GF.Contig + "_Ref|" + AnnSplit[0].substring(7);
//								}
//									//no tRNAs reported in the files
//							} else if (GF.Type.equals("tRNA")){
//								
//							}
//						} 

						//Add genomic feature to list
						Features.add(GF);
					} 
//					else if (L[2].equals("gene")){
//						String Annotation = L[8];
//						String[] AnnSplit = Annotation.split(";");
//						PBCVID = AnnSplit[1].substring(5);
//						System.out.println(PBCVID);
//					}
				}
			}
			
			//close file stream
			br.close();
			
			//add finished list to hashmap - note, uses the technical name!
			Chloroviruses.put(orgname, Features);
			
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	//Import + Map clusters - version 1 (before 10-28-2013)
	public static void ImportAndMapClusters(){
		try {
			BufferedReader br = new BufferedReader(new FileReader(ClusterFile));
			String Line = null;
			int ClusterNum = 0;
			int MappedEntryCounter = 0;
			int IgnoredEntry = 0;
			LinkedList<String> ValidNoMapping = new LinkedList<String>();
			boolean FoundMapping = false;
			
			while ((Line = br.readLine()) != null){
				MappedEntryCounter = 0;
				IgnoredEntry = 0;
				ClusterNum++;
				String[] IDs = Line.split("\t");
				ValidNoMapping = new LinkedList<String>();
				
				//map each ID appropriately
				for (int i = 0; i < IDs.length; i++){
					
					FoundMapping = false;
					String WholeID = IDs[i];
					String[] Org = WholeID.split("\\|");
					if (Org[0].contains("_Ref")){
						Org[0] = Org[0].replaceAll("_Ref", "");
					}
					
					//display to screen
					//System.out.println(WholeID + " From " + Org[0]);
					
					//cluster IDs to ignore -- bugs not included??
					if (!Org[0].equals("CME6") && !Org[0].equals("OlV1") 
							&& !Org[0].equals("OsV5") && !Org[0].equals("OtV1")
							&& !Org[0].equals("OtV2")){
						
						//null check
						if (Chloroviruses.get(Org[0]) != null){
							
							//retrieve features
							LinkedList<GenomicFeature> FList = Chloroviruses.get(Org[0]);
							
							//Search features in the appropriate organism.
							for (GenomicFeature GF : FList){
								try {
									if (GF.GeneID.equals(WholeID)){
										GF.ClusterNum = ClusterNum;
										GFs4Export.add(GF);
										MappedEntryCounter++;
										FoundMapping = true;
										break;
									} 
								} catch (Exception ex){
									// System.out.println("Bad ID: " + WholeID);
								 }
							}
						}
						
						//Note missed IDs
						if (!FoundMapping){
							ValidNoMapping.add(WholeID);
						}
						
					} else {
						IgnoredEntry++;
					}
				}
				
				//message
				String disp = "Cluster " + String.valueOf(ClusterNum) 
						+ ": Start with " + String.valueOf(IDs.length) 
						+ ", Map " + String.valueOf(MappedEntryCounter) 
						+ " Ignore " + String.valueOf(IgnoredEntry)
						+ " Missed " + String.valueOf(ValidNoMapping.size());
				String mappings = ":";
				for (String s: ValidNoMapping){
					mappings = mappings + " " + s;
				}
				disp = disp + mappings;
				System.out.println(disp);
				
				//large cluster cutoff
				if (MappedEntryCounter > LargeClusterCutoff){
					LargeClusters.add(ClusterNum);
				}
			}
			
			//note largest cluster
			LargestCluster = ClusterNum;
			System.out.println("Number of large clusters : " + LargeClusters.size());
			//close stream
			br.close();
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}
		
	//Import + Map clusters - version 2 (10-28-2013)
	public static void ImportAndMapClusters2(){
	
		int ClusterNumCounter = -1;
		ClusterDirectory = new LinkedList<ClusterData>();
		ClusterDirectoryHash = new LinkedHashMap<Integer, ClusterData>();
		
		//debugging
		LinkedHashMap<String,String> SwitchOuts = new LinkedHashMap<String,String>();
		SwitchOuts.put("NC64A_IL-5-2s1_427R.1", "NC64A_IL-5-2s1_428R.1");
		SwitchOuts.put("Pbi_CVR-1_489L.1", "Pbi_CVR-1_490L.1");
		
		try {
			//read in file
			BufferedReader br_core = new BufferedReader(new FileReader(CoreClustersFile));
			String Line = null;
			while ((Line = br_core.readLine()) != null){
				
				//increment counter
				ClusterNumCounter++;
				
				//parse the line
				if (ClusterNumCounter > 0){
				
					//retrieve data
					String[] L = Line.split(",");
					
					//create cluster data
					ClusterData CD = new ClusterData();
					CD.ClusterID = L[0];
					CD.ClusterNum = ClusterNumCounter;
					CD.Origin = L[1];
					CD.isCore = true;
					CD.Size = Integer.parseInt(L[2]);
					CD.Annotation = L[3];
					
					LinkedList<String> GeneIDList = new LinkedList<String>();
					String[] GeneIDs = L[4].split("\\s+");
					
					//remove all duplicates in gene IDs
					HashSet<String> GeneIDHash = new HashSet<String>();
					for (String s : GeneIDs){
						GeneIDHash.add(s);
					}
					Iterator<String> it = GeneIDHash.iterator();
					
					//re-format each appropriately
					while (it.hasNext()){
						
						//retrieve String
						String s = it.next();
						
						//remove tag at front
						s = s.replaceAll("NC64A_", "");
						s = s.replaceAll("Pbi_", "");
						s = s.replaceAll("SAG_", "");
						
						//remove _Ref tags
						s = s.replaceAll("_Ref", "");
												
						//find organism
						String[] OrgName = s.split("_");
						
						//retrieve features
						LinkedList<GenomicFeature> Features = Chloroviruses.get(OrgName[0]);
						
						//iterate through features
						if (Features != null){
							
							//note for later
							GeneIDList.add(s);
							
							//map cluster ID to feature
							for (GenomicFeature GF : Features){
								
								//find appropriate gene ID
								if (GF.GeneID != null){
									if (GF.GeneID.equals(s)){
										
										//check for match
										if (CD.ClusterNum != GF.ClusterNum){
											System.out.println("Disagree number!");
										}
										
										//cluster ID found.
										break;
									}
								} else if (!GF.Type.equals("tRNA")){
									System.out.println("Disagree null: " + GF.GeneID);
								}
							}
						}	
					}
					
					//write these IDs to structure
					CD.MemberGeneIDs = GeneIDList;	
					
					//store in directory + hash
					ClusterDirectory.add(CD);
					ClusterDirectoryHash.put(CD.ClusterNum,CD);
				}
			}

			//close file stream
			br_core.close();
			
			//System.out.println("Core Clusters: " + ClusterNumCounter);
			
			//open new file stream - add remaining clusters
			BufferedReader br_all = new BufferedReader(new FileReader(AllClustersFile));
			Line = null;
			boolean FirstLine = true;
			int CapturedCoreClusterCounter = 0;
			int EmptyClusterCounter = 0;
			int ActualLineCounter = 0;
			int RecheckCoreClusterCounter = 0;
			LinkedList<String> LineClusterChecks = new LinkedList<String>();
			while ((Line = br_all.readLine()) != null){
				
				//parse the line
				if (!FirstLine){
				
					//increment counter
					ClusterNumCounter++;
					ActualLineCounter++;
					
					//retrieve data
					String[] L = Line.split(",");
					
					//create cluster data
					ClusterData CD = new ClusterData();
					CD.ClusterID = L[0];
					CD.ClusterNum = ClusterNumCounter;
					CD.Origin = L[1];
					CD.isCore = false;
					CD.Size = Integer.parseInt(L[2]);
					CD.Annotation = L[3];
										
					LinkedList<String> GeneIDList = new LinkedList<String>();
					String[] GeneIDs = L[4].split("\\s+");
					
					//note this for later
					LineClusterChecks.add(L[0]);
					
					//keep track of mapping - to determine if this cluster has already been written
					boolean NewCluster = true;
					
					//remove all duplicates in gene IDs
					HashSet<String> GeneIDHash = new HashSet<String>();
					for (String s : GeneIDs){

						//correct switchouts
						if (SwitchOuts.get(s) != null){
							s = SwitchOuts.get(s);
							//System.out.println(s);
						}
						
						//add to hash map
						GeneIDHash.add(s);
						
					}
					Iterator<String> it = GeneIDHash.iterator();
						
					//note genomes featured in this cluster
					HashSet<String> ValidGenomesFeatured = new HashSet<String>();
					
					//look through each unique ID
					while (it.hasNext()){
						String s = it.next();
						
						//remove tag at front
						s = s.replaceAll("NC64A_", "");
						s = s.replaceAll("Pbi_", "");
						s = s.replaceAll("SAG_", "");
						
						//remove _Ref tags
						s = s.replaceAll("_Ref", "");
						
						//find organism
						String[] OrgName = s.split("_");
						
						//retrieve features
						LinkedList<GenomicFeature> Features = Chloroviruses.get(OrgName[0]);
						
						//iterate through features
						if (Features != null){
							
							//is this genome in the set of available genomes?
							ValidGenomesFeatured.add(OrgName[0]);
							
							//note for later
							GeneIDList.add(s);
							
							//set cluster to false here - need to find a match to reclaim
							NewCluster = false;
							
							//map cluster ID to feature
							for (GenomicFeature GF : Features){
								
								//find appropriate gene ID
								if (GF.GeneID != null){ //avoid tRNAs
									if (GF.GeneID.equals(s)){
										
										//cluster num should be novel
										if (GF.ClusterNum == 0){
												
											//update cluster number + break.
											GF.ClusterNum = CD.ClusterNum;
											//AtLeastOne = true;
											NewCluster = true;
											break;
										}
									}
								}
							}
						}	
						
						//cluster is not to be written; make necessary adjustments
						if (!NewCluster){
							
							/*
							 * Problem found!
							 * the gene
							 * IL-5-2s1_427R
							 * was not included in the original .gff file.
							 * 
							 * therfore, need to check for disagreements between
							 * the genes in adrien's gff files
							 * and the resulting
							 * JCE-imported files.
							 */							
//							if (CD.ClusterID.equals("CN0007") || CD.ClusterID.equals("CN0006")){
//								//System.out.println(s);
//								//System.out.println("Breakpoint!");
//							}
							
							ClusterNumCounter--;
							CapturedCoreClusterCounter++;
							break;
						}

					}
					
					//cases exist!
					if (ValidGenomesFeatured.size() == 0){
						//System.out.println(L[4]);
						NewCluster = false;
						ClusterNumCounter--;
						EmptyClusterCounter++;
					} else if (ValidGenomesFeatured.size() == 41){
						RecheckCoreClusterCounter++;
					}
							
					//write these IDs to structure
					CD.MemberGeneIDs = GeneIDList;	
					
					//store in directory + hash
					if (NewCluster){
						ClusterDirectory.add(CD);
						ClusterDirectoryHash.put(CD.ClusterNum,CD);
					}

				} else {
					FirstLine = false;
				}
			}

			//close file stream
			br_all.close();
			
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	//Import + Map clusters - version 3 (used on 10-29-2013 for debugging)
	public static void ImportAndMapClusters3(){
		ClusterDirectory = new LinkedList<ClusterData>();
		try {
			//open new file stream - add remaining clusters
			BufferedReader br_all = new BufferedReader(new FileReader(AllClustersFile));
			String Line = null;
			boolean FirstLine = true;
			
			//counters (for debugging)
			int ClusterNumCounter = 0;
			int EmptyClusterCounter = 0;
			int ActualLineCounter = 0;
			int RecheckCoreClusterCounter = 0;
			LinkedList<String> LineClusterChecks = new LinkedList<String>();
			
			while ((Line = br_all.readLine()) != null){
				
				//parse the line
				if (!FirstLine){
				
					//increment counter
					ClusterNumCounter++;
					ActualLineCounter++;
					
					//retrieve data
					String[] L = Line.split(",");
					
					//create cluster data
					ClusterData CD = new ClusterData();
					CD.ClusterID = L[0];
					CD.ClusterNum = ClusterNumCounter;
					CD.Origin = L[1];
					CD.isCore = false;
					CD.Size = Integer.parseInt(L[2]);
					CD.Annotation = L[3];
										
					LinkedList<String> GeneIDList = new LinkedList<String>();
					String[] GeneIDs = L[4].split("\\s+");
					
					//note this for later
					LineClusterChecks.add(L[0]);
					
					//keep track of mapping - to determine if this cluster has already been written
					boolean NewCluster = true;
					
					//remove all duplicates in gene IDs
					HashSet<String> GeneIDHash = new HashSet<String>();
					for (String s : GeneIDs){
						GeneIDHash.add(s);
					}
					Iterator<String> it = GeneIDHash.iterator();
						
					//note genomes featured in this cluster
					HashSet<String> ValidGenomesFeatured = new HashSet<String>();
					
					//look through each unique ID
					while (it.hasNext()){
						String s = it.next();
						
						//remove tag at front
						s = s.replaceAll("NC64A_", "");
						s = s.replaceAll("Pbi_", "");
						s = s.replaceAll("SAG_", "");
						
						//remove _Ref tags
						s = s.replaceAll("_Ref", "");
						
						//find organism
						String[] OrgName = s.split("_");
						
						//retrieve features
						LinkedList<GenomicFeature> Features = Chloroviruses.get(OrgName[0]);
						
						//iterate through features
						if (Features != null){
							
							//is this genome in the set of available genomes?
							ValidGenomesFeatured.add(OrgName[0]);
							
							//note for later
							GeneIDList.add(s);
							
							//set cluster to false here - need to find a match to reclaim
							NewCluster = false;
							
							//map cluster ID to feature
							for (GenomicFeature GF : Features){
								
								//find appropriate gene ID
								if (GF.GeneID != null){ //avoid tRNAs
									if (GF.GeneID.equals(s)){
										
										//update cluster number + break.
										GF.ClusterNum = CD.ClusterNum;
										NewCluster = true;
										break;
									}
								}
							}
						}	
					}
					
					//cases exist!
					if (ValidGenomesFeatured.size() == 0){
						NewCluster = false;
						ClusterNumCounter--;
						EmptyClusterCounter++;
					} else if (ValidGenomesFeatured.size() == 41){
						RecheckCoreClusterCounter++;
					}
							
					//write these IDs to structure
					CD.MemberGeneIDs = GeneIDList;	
					
					//store in directory
					if (NewCluster){
						ClusterDirectory.add(CD);
					}

					
				} else {
					FirstLine = false;
				}
			}

			//close file stream
			br_all.close();
			
			//display
			System.out.println("Lines: " + ActualLineCounter);
			System.out.println("Core recheck: " + RecheckCoreClusterCounter);
			System.out.println("Valid Clusters: " + ClusterDirectory.size() 
						+ " Empty Clusters: " + EmptyClusterCounter
						+ " Total: " + (ClusterDirectory.size()+EmptyClusterCounter+1));
			System.out.println("Line-cluster checks: " + LineClusterChecks.size());
			
			for (String s : LineClusterChecks){
				boolean FoundIt = false;
				for (ClusterData CD : ClusterDirectory){
					if (CD.ClusterID.equals(s)){
						FoundIt = true;
						break;
					}
				}
				if (!FoundIt){
					System.out.println(s);
				}
			}

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
	//Evaluate cluster file
	public static void EvaluateClusterFile(){
		
		//initialize data
		LinkedList<ClusterData> ClustersFromFile = new LinkedList<ClusterData>();
		HashSet<String> GeneIDCodes = new HashSet<String>();
		
		try {
			BufferedReader br = new BufferedReader(new FileReader(AllClustersFile));
			String Line = null;
			boolean FirstLine = true;
			int ClusterNumCounter = 0;
			while ((Line = br.readLine()) != null){
				
				//parse the line
				if (!FirstLine){
				
					//increment counter
					ClusterNumCounter++;
					
					//retrieve data
					String[] L = Line.split(",");
					
					//create cluster data
					ClusterData CD = new ClusterData();
					CD.ClusterID = L[0];
					CD.ClusterNum = ClusterNumCounter;
					CD.Origin = L[1];
					CD.isCore = false;
					CD.Size = Integer.parseInt(L[2]);
					CD.Annotation = L[3];	
					LinkedList<String> GeneIDList = new LinkedList<String>();
					String[] GeneIDs = L[4].split("\\s+");
					for (String s : GeneIDs){
						GeneIDList.add(s);
						GeneIDCodes.add(s);
					}
					CD.MemberGeneIDs = GeneIDList;
				
					//add cluster to list
					ClustersFromFile.add(CD);
				
				} else {
					FirstLine = false;
				}
			}
			
			//evaluate
			for (String s : GeneIDCodes){
				int Counter = 0;
				String str = s + ":\t";
				for (ClusterData CD : ClustersFromFile){
					if (CD.MemberGeneIDs.contains(s)){
						str = str + CD.ClusterID + " ";
						Counter++;
					}
				}
				if (Counter > 1){
					str = str + " " + String.valueOf(Counter) + " instances.";
					System.out.println(str);
				}

			}
			
			
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	//Import Cluster Number -> annotation mapping
	public static void ImportClusterAnnotations(){
		try {
			int i = 0;
			BufferedReader br = new BufferedReader(new FileReader(ClusterMappingFile));
			String Line = null;
			while ((Line = br.readLine()) != null){
				i++;
				ClusterAnnotations.put(i, Line);
			}
		} catch (Exception ex){
			ex.printStackTrace();
		}
		
		//add annotations
		for (ClusterData CD : ClusterDirectory){
			if (ClusterAnnotations.get(CD.ClusterNum) == null){
				ClusterAnnotations.put(CD.ClusterNum, CD.Annotation);
			}
		}
		
	}
	
	//Create a database of Features, for mapping cluster IDs to
	public static void CreateGFFDatabase(){
		
		//Initialize cluster counts hash map.
		ClusterCounts = new LinkedHashMap<Integer,Integer>();
		ImportedNonLargeCoreGenes = new HashSet<GenomicFeature>(); 
		//import all data
		for (String s : OrgNames.keySet()){
			String OrgFile = OrgNames.get(s);
			String file = DataDir + "/" + OrgFile + ".gff";
			ImportGFFFile(file, s);
		}
		
		//Map clusters
		//no longer needed after 10-17-2013
		//ImportAndMapClusters();
		
		//update - include both core and non-core clusters
		ImportAndMapClusters2();
		
		//count directly from loaded database
		DetermineLargeClusters();
		
	}
	
	//Determine large clusters
	public static void DetermineLargeClusters(){
		
		//new approach: 10-30-2013
		//large cluster cutoff
		int TotalLargeClusters = 0;
		LargestCluster = 0;
		for (ClusterData CD : ClusterDirectory){
			if (CD.isCore){
				if (CD.Size > LargeClusterCutoff){
					LargeClusters.add(CD.ClusterNum);
					CD.isLargeCluster = true;
					TotalLargeClusters++;
					System.out.println("Cluster " + CD.ClusterNum + ": " + CD.Size + " instances.");
				} else {
					//increment counter of non-large, core gene clusters
					NonLargeCoreGeneCount = NonLargeCoreGeneCount + CD.Size;
					CD.isLargeCluster = false;
				}
			} else {
				NonLargeNonCoreGeneCount = NonLargeNonCoreGeneCount + CD.Size;
				CD.isLargeCluster = false;
			}
			
			//determine largest cluster
			if (CD.Size > LargestCluster){
				LargestCluster = CD.Size;
			}
		}
		
		System.out.println(TotalLargeClusters + " large clusters found.");
		
//		int TotalLargeClusters = 0;
//		LargestCluster = 0;
//		for (Integer x : ClusterCounts.keySet()){
//			
//			//large cluster cutoff
//			if (ClusterCounts.get(x) > LargeClusterCutoff){
//				LargeClusters.add(x);
//				TotalLargeClusters++;
//				System.out.println("Cluster " + x +": " + ClusterCounts.get(x) + " instances.");
//			} else {
//				//increment counter of non-large clusters
//				NonLargeCoreGeneCount = NonLargeCoreGeneCount + ClusterCounts.get(x);
//			}
//			
//			//determine largest cluster
//			if (x > LargestCluster){
//				LargestCluster = x;
//			}
//
//		}
//		
//		System.out.println(TotalLargeClusters + " large clusters found.");
	
//		//debugging
//		//TODO: counts diagreement - working.
//		int SecondCount = 0;
//		for (String s : Chloroviruses.keySet()){
//			LinkedList<GenomicFeature> Features = Chloroviruses.get(s);
//			for (GenomicFeature GF : Features){
//				if (!LargeClusters.contains(GF.ClusterNum) && GF.ClusterNum != 0){
//					SecondCount++;
//				}
//			}
//		}
//		
//		System.out.println("NonLarge Gene Count 1: " + NonLargeCoreGeneCount +
//				" NonLarge Gene Count 2: " + SecondCount);
	}
	
	//Export a cluster file
	public static void ExportClusterFile(){
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(OutputFile));
			for (GenomicFeature GF : GFs4Export){
				String str = OrgNames.get(GF.OrgName) + "\t" 
						+ GF.Contig + "\t" 
						+ String.valueOf(GF.StartPos) + "\t"
						+ String.valueOf(GF.StopPos) + "\t"
						+ String.valueOf(GF.ClusterNum) 
						+ "\n";
				bw.write(str);
				bw.flush();
			}
			bw.close();
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	//Export a gene ID file
	public static void ExportGeneIDFile(){
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(GeneIDFile));
			for (String s : OrgNames.keySet()){
				String OrgFile = OrgNames.get(s);
				LinkedList<GenomicFeature> Features = Chloroviruses.get(s);
				
				for (GenomicFeature GF : Features){
					if (GF.GeneID != null){
						String str = OrgFile + "\t" 
								+ GF.Contig + "\t" 
								+ String.valueOf(GF.StartPos) + "\t"
								+ String.valueOf(GF.StopPos) + "\t"
								+ GF.GeneID + "\n";
						bw.write(str);
						bw.flush();
					}
				}
			}
			bw.close();
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	//Export an extended gff file
	public static void ExportExtendedGFFFile(String FileName, String OrgKey, boolean ExcludeZeros){
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(FileName));
			LinkedList<GenomicFeature> Features = Chloroviruses.get(OrgKey);
			for (GenomicFeature GF : Features){
				boolean WriteFeature = true;
				String str = GF.Contig + "\tGenBank\t" + GF.Type + "\t"
						+ String.valueOf(GF.StartPos) + "\t" + String.valueOf(GF.StopPos)
						+ "\t+\t" + String.valueOf(GF.Strand) + "\t.\t" 
						+ GF.Annotation + "\t" + String.valueOf(GF.ClusterNum)
						+ "\t" + GF.GeneID + "\n";
				
				//check for excluding zeros
				if (ExcludeZeros){
					if (GF.Type.equals("CDS") && GF.ClusterNum == 0){
						//System.out.println(GF.GeneID);
						WriteFeature = false;
					}
				}
				
				//write feature, if appropriate
				if (WriteFeature){
					bw.write(str);
					bw.flush();
				}
			}
			bw.close();
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	//load all data
	public static void LoadAllData(){
		
		//Initializations
		Chloroviruses = new LinkedHashMap<String, LinkedList<GenomicFeature>>();
		OrgNames = new LinkedHashMap<String, String>();
		GFs4Export = new LinkedList<GenomicFeature>();
		
		//Import GFF + clusters
		ImportOrgNames();
		CreateGFFDatabase();
		ImportClusterAnnotations();
		
		//Import sequence data
		ImportTranslationFileList();
	}
	
	// SEQUENCE MANIPULATION - for phylo trees + GC content
	
	//Import genome seq map
	public static void ImportGenomeFileList(){
		GenomeFiles = new LinkedHashMap<String,String>();
		try {
			BufferedReader br  = new BufferedReader(new FileReader(GenomeFile));
			String Line = null;
			while((Line = br.readLine()) != null){
				String[] Path = Line.split("/");
				String[] Name = Path[Path.length-1].split(".fasta");
				GenomeFiles.put(Name[0],Line);
			}
			br.close();
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}

	//Import protein translation map
	public static void ImportTranslationFileList(){
		TranslationFiles = new LinkedHashMap<String,String>();
		try {
			BufferedReader br  = new BufferedReader(new FileReader(TranslationFileList));
			String Line = null;
			while((Line = br.readLine()) != null){
				String[] Path = Line.split("/");
				String[] Name = Path[Path.length-1].split(".fasta");
				TranslationFiles.put(Name[0],Line);
			}
			br.close();
		} catch (Exception ex){
			ex.printStackTrace();
		}
	}
	
	//Protein sequences
	//Retrieve a single protein sequence: list.get(0) = header, list.get(1) = seq
	public static LinkedList<String> ProteinSequence(GenomicFeature E){
		
		//Initialize output
		LinkedList<String> ProteinSequence = new LinkedList<String>();
		
		try {
			
			//Retrieve file name
			String TransFile = TranslationFiles.get(E.OrgName);
			
			BufferedReader br = new BufferedReader(new FileReader(TransFile));
			String Line = null;
			boolean FoundTheProtein = false;
			
			while ((Line = br.readLine()) != null){
				
				//find protein, or read protein sequence.
				if (Line.startsWith(">")){
					
//					if (Line.equals(">Br0604L--117513--117869")){
//						System.out.println("Breakpoint!");
//					}
					
					String[] L = Line.split("\\--");
					
					String Contig = L[0].substring(1);
					int StartPos = Integer.parseInt(L[1]);
					int StopPos = Integer.parseInt(L[2]);
					
					//check for match
					if (E.Contig.equals(Contig) &&
							(Math.abs(E.StartPos-StartPos)<BubbleRange ||
									Math.abs(E.StopPos-StopPos)<BubbleRange)){
						FoundTheProtein = true;
						String LineAndNewLine = Line;
						ProteinSequence.add(LineAndNewLine);
					}
					
				} else if (FoundTheProtein){
					String LineAndNewLine = Line;
					ProteinSequence.add(LineAndNewLine);
					
					//after the empty line, break out of loop.
					if (Line.equals("")){
						break;
					}
				}
				
			}
			
			//close file stream
			br.close();
			
		} catch (Exception ex){
			ex.printStackTrace();
		}
		
		//return statement
		return ProteinSequence;
	}
	
	// ---UNFINISHED--- needs debugging
	//Retrieve a single stretch of nucleotides
	public static String GetNucleotides(String Organism, String Contig, int StartCoord, int StopCoord){
		
		//Initialize output 
		String nt = "";
		
		try{
			
			//Retrieve genome
			BufferedReader br = new BufferedReader(new FileReader(GenomeFiles.get(Organism)));
			String Line = null;
			boolean FoundContig = false;
			boolean StartedSequence = false;
			boolean NewLine = true;
			int CoordCounter = 0;
			while ((Line = br.readLine()) != null){
				
				//every new line - set switch
				NewLine = true;
				
				//find appropriate header
				if (Line.startsWith(">")){
					if (Line.contains(Contig)){
						FoundContig = true;
					}
				} else if (FoundContig){
					
					 //check for starting a sequence
					 if (!StartedSequence){
						 if (StartCoord - CoordCounter <= FastaLineLength){
							 nt = Line.substring((StartCoord-CoordCounter-1), Line.length()).toUpperCase();
							 StartedSequence = true;
							 NewLine = false;
						 } 
					 } else {
						 NewLine = true;
					 }
					 
				     //once started, write until appropriate to stop
					 if (StartedSequence){
						 if (StopCoord - CoordCounter <= FastaLineLength){
							 nt = nt + Line.substring((StopCoord-CoordCounter-1),Line.length()).toUpperCase();
							 break;
						 } else if (NewLine){ //add whole line
							 nt = nt + Line.toUpperCase();
						 }
					 }
					 
					 //increment counter, unless stop is nearby
					 CoordCounter = CoordCounter + FastaLineLength;
				}
			}
			
		} catch (Exception ex){
			ex.printStackTrace();
		}
		
		//return statement
		return nt;
	}

	//main method
	public static void main(String[] args) {
		//Initializations
		LoadAllData();
		
		//Export
		//ExportClusterFile();
		//ExportGeneIDFile();
		
		//for debugging
		//EvaluateClusterFile();
		
//		//Export genomes: Oct 30, 2013
//		for (String s : Chloroviruses.keySet()){
//			//String FileName = GFFExportDir + "/" + s + ".gff";
//			String FileName = GFFNoMinorORFsExportDir + "/" + s + ".gff";
//			ExportExtendedGFFFile(FileName,s,true);
//		}
		
//		//debugging
//		for (String s : TranslationFiles.keySet()){
//			System.out.println(s + "\t" + TranslationFiles.get(s));
//		}
				
		//Output message
		System.out.println("All Processes Successfully Completed!");
	}

}
